/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the AddSegmentGroupRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AddSegmentGroupRequest{}

// AddSegmentGroupRequest struct for AddSegmentGroupRequest
type AddSegmentGroupRequest struct {
	SelectedIds []string `json:"selected_ids,omitempty"`
	SelectionMode string `json:"selection_mode"`
	Segment *AddSegmentGroupRequestSegment `json:"segment,omitempty"`
}

// NewAddSegmentGroupRequest instantiates a new AddSegmentGroupRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAddSegmentGroupRequest(selectionMode string) *AddSegmentGroupRequest {
	this := AddSegmentGroupRequest{}
	this.SelectionMode = selectionMode
	return &this
}

// NewAddSegmentGroupRequestWithDefaults instantiates a new AddSegmentGroupRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAddSegmentGroupRequestWithDefaults() *AddSegmentGroupRequest {
	this := AddSegmentGroupRequest{}
	return &this
}

// GetSelectedIds returns the SelectedIds field value if set, zero value otherwise.
func (o *AddSegmentGroupRequest) GetSelectedIds() []string {
	if o == nil || IsNil(o.SelectedIds) {
		var ret []string
		return ret
	}
	return o.SelectedIds
}

// GetSelectedIdsOk returns a tuple with the SelectedIds field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AddSegmentGroupRequest) GetSelectedIdsOk() ([]string, bool) {
	if o == nil || IsNil(o.SelectedIds) {
		return nil, false
	}
	return o.SelectedIds, true
}

// HasSelectedIds returns a boolean if a field has been set.
func (o *AddSegmentGroupRequest) HasSelectedIds() bool {
	if o != nil && !IsNil(o.SelectedIds) {
		return true
	}

	return false
}

// SetSelectedIds gets a reference to the given []string and assigns it to the SelectedIds field.
func (o *AddSegmentGroupRequest) SetSelectedIds(v []string) {
	o.SelectedIds = v
}

// GetSelectionMode returns the SelectionMode field value
func (o *AddSegmentGroupRequest) GetSelectionMode() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.SelectionMode
}

// GetSelectionModeOk returns a tuple with the SelectionMode field value
// and a boolean to check if the value has been set.
func (o *AddSegmentGroupRequest) GetSelectionModeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.SelectionMode, true
}

// SetSelectionMode sets field value
func (o *AddSegmentGroupRequest) SetSelectionMode(v string) {
	o.SelectionMode = v
}

// GetSegment returns the Segment field value if set, zero value otherwise.
func (o *AddSegmentGroupRequest) GetSegment() AddSegmentGroupRequestSegment {
	if o == nil || IsNil(o.Segment) {
		var ret AddSegmentGroupRequestSegment
		return ret
	}
	return *o.Segment
}

// GetSegmentOk returns a tuple with the Segment field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AddSegmentGroupRequest) GetSegmentOk() (*AddSegmentGroupRequestSegment, bool) {
	if o == nil || IsNil(o.Segment) {
		return nil, false
	}
	return o.Segment, true
}

// HasSegment returns a boolean if a field has been set.
func (o *AddSegmentGroupRequest) HasSegment() bool {
	if o != nil && !IsNil(o.Segment) {
		return true
	}

	return false
}

// SetSegment gets a reference to the given AddSegmentGroupRequestSegment and assigns it to the Segment field.
func (o *AddSegmentGroupRequest) SetSegment(v AddSegmentGroupRequestSegment) {
	o.Segment = &v
}

func (o AddSegmentGroupRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AddSegmentGroupRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.SelectedIds) {
		toSerialize["selected_ids"] = o.SelectedIds
	}
	toSerialize["selection_mode"] = o.SelectionMode
	if !IsNil(o.Segment) {
		toSerialize["segment"] = o.Segment
	}
	return toSerialize, nil
}

type NullableAddSegmentGroupRequest struct {
	value *AddSegmentGroupRequest
	isSet bool
}

func (v NullableAddSegmentGroupRequest) Get() *AddSegmentGroupRequest {
	return v.value
}

func (v *NullableAddSegmentGroupRequest) Set(val *AddSegmentGroupRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAddSegmentGroupRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAddSegmentGroupRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAddSegmentGroupRequest(val *AddSegmentGroupRequest) *NullableAddSegmentGroupRequest {
	return &NullableAddSegmentGroupRequest{value: val, isSet: true}
}

func (v NullableAddSegmentGroupRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAddSegmentGroupRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


